package org.bitbucket.bradleysmithllc.webserviceshubclient;

import javax.xml.namespace.QName;
import javax.xml.soap.SOAPElement;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPHeader;
import javax.xml.soap.SOAPMessage;
import javax.xml.ws.handler.MessageContext;
import javax.xml.ws.handler.soap.SOAPHandler;
import javax.xml.ws.handler.soap.SOAPMessageContext;
import java.util.Set;

public class SessionIdHandler implements SOAPHandler
{
	private String sessionId;

	public boolean handleMessage(MessageContext context)
	{
		SOAPMessageContext smc = (SOAPMessageContext) context;

		Boolean outboundProperty = (Boolean) context.get(MessageContext.MESSAGE_OUTBOUND_PROPERTY);

		if (outboundProperty.booleanValue() && sessionId != null)
		{
			SOAPMessage message = smc.getMessage();

			try
			{
				SOAPEnvelope envelope = message.getSOAPPart().getEnvelope();
				SOAPHeader header = envelope.addHeader();

				String WSSE_NS = "http://www.informatica.com/wsh/";
				String WSSE_PREFIX = "infa";

				SOAPElement scontext = header.addChildElement("Context", WSSE_PREFIX, WSSE_NS);
				SOAPElement sessionElemeent = scontext.addChildElement("SessionId");
				sessionElemeent.addTextNode(sessionId);
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}

		return outboundProperty;
	}

	public Set<QName> getHeaders()
	{
		return null;
	}

	public boolean handleFault(MessageContext context)
	{
		return false;
	}

	public void close(MessageContext context)
	{
	}

	public void setSessionId(String sessionId)
	{
		this.sessionId = sessionId;
	}
}